<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');
 
// import Joomla modelitem library
jimport('joomla.application.component.model');

class JumbotronModelSchoolSportSchedule extends JModel
{
	public function getSchool()
	{
		$school_id = JRequest::getInt('school');

		$row = JTable::getInstance('School', 'JumbotronTable');
		$row->load($school_id);

		return $row;
	}

	public function getSport()
	{
		$sport_id = JRequest::getInt('sport');

		$row = JTable::getInstance('Sport', 'JumbotronTable');
		$row->load($sport_id);

		return $row;
	}

	public function getGames()
	{
		$school_id = JRequest::getInt('school');
		$sport_id = JRequest::getInt('sport');
		
		$db = $this->getDbo();
		$query = $db->getQuery(true);

		//Get game info
		$query->select
			(
				'g.id AS game_id, g.game_date AS game_date, g.season AS season, g.final_type AS final, g.tba AS tba, '.
				'g.home_team AS home_team, g.away_team AS visitor, '.
				'g.visitor_two AS visitor2, g.visitor_three AS visitor3, '.
				'g.visitor_four AS visitor4, g.visitor_five AS visitor5, '.
				'g.visitor_six AS visitor6, g.visitor_seven AS visitor7, '.
				'g.visitor_eight AS visitor8, g.visitor_nine AS visitor9, '.
				'g.tourney AS tourney, g.game_intro AS game_intro'
			);
		$query->from('#__jumbotron_games AS g');

		//JOIN the home_team
		$query->select('ht.id AS home_id, ht.school_id AS home_sid, ht.sports_id AS home_sport');
		$query->join('LEFT', '#__jumbotron_teams AS ht ON ht.id = g.home_team');
		
		//JOIN the home school
		$query->select('hs.id AS home_team, hs.school_name AS home_school, hs.school_medium AS home_medium, '.
			'hs.school_display AS home_display, hs.school_nickname AS home_mascot');
		$query->join('LEFT', '#__jumbotron_schools AS hs ON hs.id = ht.school_id');

		//JOIN the away_team
		$query->select('at.id AS away_id, at.school_id AS away_sid, at.sports_id AS away_sport');
		$query->join('LEFT', '#__jumbotron_teams AS at ON at.id = g.away_team');
		
		//JOIN the away school
		$query->select('ts.id AS away_team, ts.school_name AS away_school, ts.school_medium AS away_medium, '.
			'ts.school_display AS away_display, ts.school_nickname AS away_mascot');
		$query->join('LEFT', '#__jumbotron_schools AS ts ON ts.id = at.school_id');
		
		//JOIN visitor 2
		$query->select('ii.id AS visitor2_id, ii.school_id AS visitor2_sid, ii.sports_id AS visitor2_sport');
		$query->join('LEFT', '#__jumbotron_teams AS ii ON ii.id = g.visitor_two');
		
		//JOIN the visitor 2 school
		$query->select('iis.id AS away2_team, iis.school_name AS away2_school, iis.school_medium AS away2_medium, '.
			'iis.school_display AS away2_display, iis.school_nickname AS away2_mascot');
		$query->join('LEFT', '#__jumbotron_schools AS iis ON iis.id = ii.school_id');
		
		//JOIN visitor 3
		$query->select('iii.id AS visitor3_id, iii.school_id AS visitor3_sid, iii.sports_id AS visitor3_sport');
		$query->join('LEFT', '#__jumbotron_teams AS iii ON iii.id = g.visitor_three');
		
		//JOIN the visitor 3 school
		$query->select('iiis.id AS away3_team, iiis.school_name AS away3_school, iiis.school_medium AS away3_medium, '.
			'iiis.school_display AS away3_display, iiis.school_nickname AS away3_mascot');
		$query->join('LEFT', '#__jumbotron_schools AS iiis ON iiis.id = iii.school_id');
		
		//JOIN visitor 4
		$query->select('iv.id AS visitor4_id, iv.school_id AS visitor4_sid, iv.sports_id AS visitor4_sport');
		$query->join('LEFT', '#__jumbotron_teams AS iv ON iv.id = g.visitor_four');
		
		//JOIN the visitor 4 school
		$query->select('ivs.id AS away4_team, ivs.school_name AS away4_school, ivs.school_medium AS away4_medium, '.
			'ivs.school_display AS away4_display, ivs.school_nickname AS away4_mascot');
		$query->join('LEFT', '#__jumbotron_schools AS ivs ON ivs.id = iv.school_id');
		
		//JOIN visitor 5
		$query->select('v.id AS visitor5_id, v.school_id AS visitor5_sid, v.sports_id AS visitor5_sport');
		$query->join('LEFT', '#__jumbotron_teams AS v ON v.id = g.visitor_five');
		
		//JOIN the visitor 5 school
		$query->select('vs.id AS away5_team, vs.school_name AS away5_school, vs.school_medium AS away5_medium, '.
			'vs.school_display AS away5_display, vs.school_nickname AS away5_mascot');
		$query->join('LEFT', '#__jumbotron_schools AS vs ON vs.id = v.school_id');
		
		//JOIN visitor 6
		$query->select('vi.id AS visitor6_id, vi.school_id AS visitor6_sid, vi.sports_id AS visitor6_sport');
		$query->join('LEFT', '#__jumbotron_teams AS vi ON vi.id = g.visitor_six');
		
		//JOIN the visitor 6 school
		$query->select('vis.id AS away6_team, vis.school_name AS away6_school, vis.school_medium AS away6_medium, '.
			'vis.school_display AS away6_display, vis.school_nickname AS away6_mascot');
		$query->join('LEFT', '#__jumbotron_schools AS vis ON vis.id = vi.school_id');
		
		//JOIN visitor 7
		$query->select('vii.id AS visitor7_id, vii.school_id AS visitor7_sid, vii.sports_id AS visitor7_sport');
		$query->join('LEFT', '#__jumbotron_teams AS vii ON vii.id = g.visitor_seven');
		
		//JOIN the visitor 7 school
		$query->select('viis.id AS away7_team, viis.school_name AS away7_school, viis.school_medium AS away7_medium, '.
			'viis.school_display AS away7_display, viis.school_nickname AS away7_mascot');
		$query->join('LEFT', '#__jumbotron_schools AS viis ON viis.id = vii.school_id');
		
		//JOIN visitor 8
		$query->select('viii.id AS visitor8_id, viii.school_id AS visitor8_sid, viii.sports_id AS visitor8_sport');
		$query->join('LEFT', '#__jumbotron_teams AS viii ON viii.id = g.visitor_eight');
		
		//JOIN the visitor 8 school
		$query->select('viiis.id AS away8_team, viiis.school_name AS away8_school, viiis.school_medium AS away8_medium, '.
			'viiis.school_display AS away8_display, viiis.school_nickname AS away8_mascot');
		$query->join('LEFT', '#__jumbotron_schools AS viiis ON viiis.id = viii.school_id');
		
		//JOIN visitor 9
		$query->select('ix.id AS visitor9_id, ix.school_id AS visitor9_sid, ix.sports_id AS visitor9_sport');
		$query->join('LEFT', '#__jumbotron_teams AS ix ON ix.id = g.visitor_nine');
		
		//JOIN the visitor 9 school
		$query->select('ixs.id AS away9_team, ixs.school_name AS away9_school, ixs.school_medium AS away9_medium, '.
			'ixs.school_display AS away9_display, ixs.school_nickname AS away9_mascot');
		$query->join('LEFT', '#__jumbotron_schools AS ixs ON ixs.id = ix.school_id');
		
		//JOIN the sport information
		$query->select('sp.id');
		$query->join('LEFT', '#__jumbotron_sports AS sp ON sp.id = ht.sports_id');
		
		//JOIN the sports_list information
		$query->select('sl.scoring_type AS scoring_type, sl.points_for AS points_for, sl.points_against AS points_against');
		$query->join('LEFT', '#__jumbotron_sports_list AS sl ON sl.id = sp.sports_id');
		
		//JOIN the stadium information if needed
		$query->select('st.school_name AS location');
		$query->join('LEFT', '#__jumbotron_schools AS st ON st.id = g.stadium_id');
		
		$query->where('g.published = 1');
		$query->where("(hs.id = '{$school_id}' OR ts.id = '{$school_id}' OR iis.id = '{$school_id}' OR iiis.id = '{$school_id}'
					 OR ivs.id = '{$school_id}' OR vs.id = '{$school_id}' OR vis.id = '{$school_id}' OR viis.id = '{$school_id}'
					  OR viiis.id = '{$school_id}' OR ixs.id = '{$school_id}')");
		$query->where("ht.sports_id = '{$sport_id}'");
		$query->where('g.game_date > NOW()');
		
		$query->order('g.game_date ASC');

		$db->setQuery($query);

		$rows = $db->loadObjectList();

		return $rows;
	}
}